
#include <time.h>
#include <stdio.h>
#include <sys/kos.h>

#include "yacasprivate.h"
#include "unixcommandline.h"

void CUnixCommandLine::NewLine()
{
    printf("\n");
}

void CUnixCommandLine::Pause()
{
    kos_Delay(250);
}

void CUnixCommandLine::ShowLine(LispChar * prompt,LispInt promptlen,LispInt cursor)
{
    if (iFullLineDirty)
    {
        printf("\r%c[K",27); //Clear line
        printf("%s%s",prompt,&iSubLine[0]); // display line
    }
    printf("\r");                     // go back
    printf("%c[%dC",27,cursor+promptlen); // position cursor
    fflush(stdout);
    iFullLineDirty = 0;
}


CUnixCommandLine::CUnixCommandLine() : iMaxLines(1024)
{
    char fname[256];
#ifdef HAVE_VSNPRINTF
    snprintf(fname,256,"%s/.yacas_history","/tmp0/1/yacas");
#else
    sprintf(fname,"%s/.yacas_history","/tmp0/1/yacas");
#endif
    FILE*f=fopen(fname,"r");
    if (f)
    {
        if(f)
        {
#define BufSz 256
            char buff[BufSz];
            while(fgets(buff,BufSz-2,f))
            {
                int i;
                for(i=0;buff[i] && buff[i] != '\n';++i)
                    ;
                buff[i++] = '\0';
                LispString * ptr = NEW LispString(buff);
                iHistoryList.Append(ptr);
 
            }
            fclose(f);
        }
    }
    iMaxLines = 1024;

}
CUnixCommandLine::~CUnixCommandLine()
{
    char fname[256];
#ifdef HAVE_VSNPRINTF
    snprintf(fname,256,"%s/.yacas_history","/tmp0/1/yacas");
#else
    sprintf(fname,"%s/.yacas_history","/tmp0/1/yacas");
#endif
 
    FILE*f=fopen(fname,"w");
    if (f)
    {
        int i;
        int from=0;
        if (iMaxLines>=0)
        {
            if (iHistoryList.NrLines()>iMaxLines)
            {
                from = iHistoryList.NrLines()-iMaxLines;
            }
        }
        for (i=from;i<iHistoryList.NrLines();i++)
        {
          LispString * ptr = iHistoryList.GetLine(i);

            fprintf(f,"%s\n",ptr->c_str());
        }
        fclose(f);
    }
}

void CUnixCommandLine::MaxHistoryLinesSaved(LispInt aNrLines)
{
    iMaxLines = aNrLines;
}


LispInt CUnixCommandLine::GetKey()
{
   /* char c = getchar();

    switch (c) {
    case 8:
        c = eBackSpace; // Backspace
        break;
    case 9: //  Tab
        c = eTab;
        break;
    case 13: // Enter
        c = eEnter;
        break;
    case 0xE0:
        c = getchar(); // Get extended scan code
        switch (c) {
        case 75: // left arrow key
            c = eLeft;
            break;
        case 77: // right arrow key
            c = eRight;
            break;
        case 72: // up arrow key
            c = eUp;
            break;
        case 80: // down arrow key
            c = eDown;
            break;
        case 71: // home
            c = eHome;
            break;
        case 79: // end
            c = eEnd;
            break;
        case 83: // delete
            c = eDelete;
            break;
        }
        break;
    }

    return c;*/
    getchar();
    return -1;
}



